#ifndef _AUDIO_IO_H_
#define _AUDIO_IO_H_

#include <string>
#include <vector>

typedef short		OUTPUT_SAMPLE;


class AudioIO 
{
	public:
		AudioIO();
		virtual ~AudioIO();
		
		bool initAudio();
		void terminateAudio();
				
		bool loadSound(const std::string& filename);
		void unloadSound();
		void playSound();
		void stopSound();
		void setSequenceToPlay(double begin, double end);
		int getMaxValue() {return max_value;}
		bool is_playing();
		/// @param elapsed_time elapsed time in milliseconds
		double getPosition(int elapsed_time);
		
		int getSoundStream(OUTPUT_SAMPLE*& stream, int& channel)
		{
			channel = nb_channels;
			stream = output_stream_data;
			return nb_frames;
		}
		
	private:
		
		
		bool audioInitOK;
		
		int output_position;
		int output_end;
		OUTPUT_SAMPLE* output_stream_data;
		int nb_channels, nb_frames, sample_rate, max_value;
		
		unsigned int al_source;
		unsigned int al_buffer;
		
};



#endif /*_AUDIO_IO_H_*/


