#include "chooseValueDialog.h"


using namespace std;



ChooseValueDialog::ChooseValueDialog()
{

}

ChooseValueDialog::ChooseValueDialog(const Glib::ustring& title, Gtk::Window& parent, bool modal, bool use_separator):
		Dialog(title, parent, modal, use_separator),
		checkbox_take_opposite("Use 0-score"),
		info("Choose the score you want to use :")
{
	add_button(Gtk::Stock::OK, Gtk::RESPONSE_OK );
	add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL );
}


ChooseValueDialog::~ChooseValueDialog()
{
	clearChoices();
}


void ChooseValueDialog::clearChoices()
{
	std::list<Gtk::RadioButton*>::iterator it;
	for(it = buttons.begin(); it!=buttons.end(); it++)
		delete (*it);
	
	buttons.clear();
}


void ChooseValueDialog::addChoice(const std::string& choice)
{
	buttons.push_back(new Gtk::RadioButton(group,choice));
}


std::string ChooseValueDialog::getChoice()
{
	std::list<Gtk::RadioButton*>::iterator it;
	for(it = buttons.begin(); it!=buttons.end(); it++)
		if ((*it)->get_active())
			return (*it)->get_label();
	
	return "";
}

void ChooseValueDialog::setCurrentChoice(const std::string& choice)
{
	std::list<Gtk::RadioButton*>::iterator it;
	for(it = buttons.begin(); it!=buttons.end(); it++)
		if ((*it)->get_label()==choice)
		{
			(*it)->set_active();
			return;
		}
}


void ChooseValueDialog::updateDialog()
{
	Gtk::VBox* v_box = get_vbox();
	
	v_box->pack_start(info);
	
	std::list<Gtk::RadioButton*>::iterator it;
	for(it = buttons.begin(); it!=buttons.end(); it++)
		v_box->pack_start(**it);
	
	v_box->pack_start(checkbox_take_opposite);
	
	set_resizable(false);
	
	show_all_children();
	
}




