#ifndef __CHOOSE_VALUE_DIALOG__
#define __CHOOSE_VALUE_DIALOG__

#include <string>
#include <list>
#include <gtkmm.h>


class ChooseValueDialog : public Gtk::Dialog
{
	public:
		ChooseValueDialog();
		ChooseValueDialog(const Glib::ustring& title, Gtk::Window& parent, bool modal=false, bool use_separator=false);
		virtual ~ChooseValueDialog();
		
		void clearChoices();
		void addChoice(const std::string& choice);
		void setCurrentChoice(const std::string& choice);
		std::string getChoice();
		void updateDialog();
		void setOppositeScore(bool opposite) { checkbox_take_opposite.set_active(opposite); }
		bool getOppositeScore() { return checkbox_take_opposite.get_active(); }
	protected:
		Gtk::RadioButton::Group group;
		std::list<Gtk::RadioButton*> buttons;
		Gtk::CheckButton checkbox_take_opposite;
		Gtk::Label info;
	
	
};





#endif /* __CHOOSE_VALUE_DIALOG__ */
