#include "graph.h"

using namespace std;


string Graphe::score_to_use;
		
		

Graphe::Graphe(int nb, int s, int e)
{
	nb_sommet = nb;
    start=s;
	end=e;
	S=new Arc*[nb];
	for(int i=0;i<nb_sommet;i++) S[i]=NULL;

}


void Graphe::ajouterArc(int sommetDepart, int sommetDestination, const std::map<std::string, double>& val, const std::string& s, int ID)
{
	if (sommetDepart>nb_sommet || sommetDestination>nb_sommet)
		return;
	
	if (S[sommetDepart]==NULL) 
		S[sommetDepart]=new Arc(sommetDestination,val,s, ID);
	else 
		S[sommetDepart]->ajoute(sommetDestination,val,s, ID);
}



double Graphe::poids(int s1,int s2)
{
	double p=0;

	if (s1==s2) return 0;
	if (S[s1]==NULL) return VAL_MAX;
	if (S[s1]->present(s2,p)) return p;
	return VAL_MAX;
}

int Graphe::Dijkstra(int s,double *distance,int *pred)
{
	int i=0,j=0,y=0;
	double m=0,v=0;
	int *M;
	Arc *pt;
	

	// Initialisation
	M=new int[nb_sommet];
	for(i=0;i<nb_sommet;i++)
	{ distance[i]=poids(s,i); pred[i]=s; M[i]=1; }

	// On supprime s de l'ensemble de sommets M et on mets dans nbElem le nb d'elements de M 
	M[s]=0;
	int nbElem=nb_sommet-1;

	while (nbElem>0)  // Tant que M n'est pas vide
	{
		for(m=VAL_MAX,i=0;i<nb_sommet;i++)
			if ((M[i])&&(distance[i]<m)) m=distance[j=i];
		
		// Car les sommets qui restent dans M ne sont pas accessibles depuis s 
		if (m==VAL_MAX)
		{
			delete [] M;
			return 0;
		}
 	    

		M[j]=0; nbElem--; //  On supprime j de M

		// Pour tous les sommets de d+ de j
		for(pt=S[j];pt;pt=pt->suivant())
			if (M[y=pt->sommet()])  // Si il est dans M
			{
				// On reajuste les valeurs de distance et pred pour y
				v=distance[j]+poids(j,y);
				if (v<distance[y]) { distance[y]=v; pred[y]=j; }
			}
	}
	
	delete [] M;
	return 1;
}

/*



void Graphe::parcours()
{
	int *marque,i;

	marque=new int[nb_sommet+1];
	for (i=0;i<=nb_sommet;i++) marque[i]=0;

	for (i=1;i<=nb_sommet;i++)
		if (marque[i]==0) profondeur(i,marque);
}

void Graphe::profondeur(int s,int *marque)
{
	Arc *pt;

	cout<<"S"<<s<<endl;
	marque[s]=1;
	for(pt=S[s];pt;pt=pt->suivant())
		if (marque[pt->sommet()]==0)
			profondeur(pt->sommet(),marque);
}



void Graphe::affiche_resultat(int s,double *distance,int *pred,int nb)
{
	int i,j;

	for (i=0;i<nb;i++)
	{
		if (distance[i]==VAL_MAX)
			;//cout<<"Pas de chemin entre "<<s<<" et "<<i<<endl;
		else
		{
			cout<<"Chemin +court entre "<<s<<" et "<<i<<endl;
			for(j=i;j!=s;j=pred[j]) cout<<j<<" <- "<<pred[j]<<"  ";
			cout<<"Cout="<<distance[i]<<endl;
		}
	}
}


void Graphe::affiche()
{
	cout << "Graphe compose de "<<nb_sommet<<endl<<"Avec les arcs suivants :"<<endl;
	for (int i=0;i<nb_sommet;i++)
		for(Arc*pt=S[i];pt;pt=pt->suivant())
			cout<<"S"<<i<<" -> "<<"S"<<pt->sommet()<<" avec un poids de : "<<pt->valeur()<<endl;
}

*/ 
