#ifndef __GRAPH__
#define __GRAPH__

#include <cstdio>
#include <iostream>
#include <string>
#include <map>

#define VAL_MAX		99999999

class Arc;

class Graphe
{
	public :
		Graphe(int nb, int s, int e);
		~Graphe() { delete S; }

		void ajouterArc(int sommetDepart, int sommetDestination, const std::map<std::string, double>& val, const std::string& s, int ID);
		double poids(int,int);
		int Dijkstra(int,double*,int*);
		
		static std::string score_to_use;

	
		void setStart(int s) { start=s; }
		int getStart() { return start; }
		void setEnd(int e) { end=e; }
		int getEnd() { return end; }

		int getNbSommets()	{return nb_sommet;}
		Arc** getSommet()	{return S;}
		
	private:
		int nb_sommet;
		int nb_arc;
		int start,end;
		Arc** S;
};


class Arc
{
	public :

		Arc(int s, const std::map<std::string, double>& val, const std::string& sdata, int ID)
		{
			destination=s;
			suiv=NULL;
			scores=val;
			data=sdata;
			id = ID;
		}

		~Arc() { delete suiv; }
				
		void ajoute(int s, const std::map<std::string, double>& val, const std::string& sdata, int ID)
		{
			if (suiv==NULL) suiv=new Arc(s, val, sdata, ID);
			else suiv->ajoute(s, val, sdata, ID);
		}

		int getID()		{return id;}
		double valeur() { return scores[Graphe::score_to_use]; }
		int sommet() { return destination; }
		std::string getData() { return data; }
		Arc *suivant() { return suiv; }

		int longueur()
		{
			if (suiv==NULL) return 1;
			else return (1+suiv->longueur());
		}

		int present(int s, double& p)
		{
			if (destination==s) { p=scores[Graphe::score_to_use]; return 1; }
			if (suiv==NULL) { p=VAL_MAX; return 0; }
			return (suiv->present(s, p));
		}
		
		void takeTheOppositeScore()
		{
			std::map<std::string,double>::iterator iter;
			for( iter = scores.begin(); iter != scores.end(); iter++ ) 
				iter->second = -iter->second;
		}
		
		void addScore(std::string name, double val) {scores[name]+=val;}
		void getScores(std::map<std::string, double>& s) { s=scores; }
		
		
	private:
		int destination;
		Arc* suiv;
		std::map<std::string, double> scores; 
		std::string data;
		int id;
};













#endif  /* __GRAPH__ */


 
